<?php
/*
Plugin Name: CRCRLF
Plugin URI: http://www.somethinkodd.com/WordPress-Email-CR-LF-Fix
Description: Fix for WordPress's CR-CR-LF problem. Corrects the WordPress email formatting problem in Microsoft Outlook, caused by WordPress incorrectly passing through Carriage Return (CR) characters before Line Feed (LF) characters, on Unix systems.
Version: 1.0
Author: OddThinking Development Team
Author URI: http://www.somethinkodd.com/oddthinking
*/

/*  Copyright 2006  SomethinkOdd (email : CRCRLF@somethinkodd.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if ( !function_exists('wp_mail') ) :
function wp_mail($to, $subject, $message, $headers = '') {
	// Find correct EOL sequence by platform. 
	// Thanks to Ivo Fokkema of LOVD (http://www.dmd.nl/LOVD/1.1.0/) for the inspiration for the OS check: 
	if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN')) {
		$s_eol = "\r\n";
		$bad_eol_sequences = array("'\r[^\n]'","'[^\r]\n'"); 
		// TODO: Doesn't cover \r as last and and \n as first characters of string.
	} elseif (strtoupper(substr(PHP_OS, 0, 3) == 'MAC')) {
		$s_eol = "\r";
		$bad_eol_sequences = array("'\r\n'","'[^\r]\n'"); 
		// TODO: Doesn't cover \n as first character of string.
	} else {
		$s_eol = "\n";
		$bad_eol_sequences = array("'\r\n'","'\r[^\n]'"); 
		// TODO: Doesn't cover \r as last character of string.
	}
	
	if( $headers == '' ) {
		$headers = "MIME-Version: 1.0". $s_eol.
			"From: wordpress@" . preg_replace('#^www\.#', '', strtolower($_SERVER['SERVER_NAME'])) . $s_eol . 
			"Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"" . $s_eol;
	}
	else {
		$headers = preg_replace($bad_eol_sequences, $s_eol, $headers);
		// TODO: I don't understand why the multiline support option isn't required in the regexp pattern...
		}

	$message = preg_replace($bad_eol_sequences, $s_eol, $message);
	
	return @mail($to, $subject, $message, $headers);
}
endif;